Index: uspace/app/netstart/self_test.c
===================================================================
--- uspace/app/netstart/self_test.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/app/netstart/self_test.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,334 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup net
+ * @{
+ */
+
+/** @file
+ * Networking self-tests implementation.
+ *
+ */
+
+#include <errno.h>
+#include <stdlib.h>
+#include <stdio.h>
+
+#include <net_checksum.h>
+#include <adt/int_map.h>
+#include <adt/char_map.h>
+#include <adt/generic_char_map.h>
+#include <adt/measured_strings.h>
+#include <adt/dynamic_fifo.h>
+
+#include "self_test.h"
+
+/** Test the statement, compare the result and evaluate.
+ *
+ * @param[in] statement The statement to test.
+ * @param[in] result    The expected result.
+ *
+ */
+#define TEST(statement, result) \
+	do { \
+		printf("\n\t%s == %s", #statement, #result); \
+		if ((statement) != (result)) { \
+			printf("\tfailed\n"); \
+			fprintf(stderr, "\nNetwork self-test failed\n"); \
+			return EINVAL; \
+		} else \
+			printf("\tOK"); \
+	} while (0)
+
+#define XMALLOC(var, type) \
+	do { \
+		(var) = (type *) malloc(sizeof(type)); \
+		if ((var) == NULL) { \
+			fprintf(stderr, "\nMemory allocation error\n"); \
+			return ENOMEM; \
+		} \
+	} while (0)
+
+GENERIC_CHAR_MAP_DECLARE(int_char_map, int);
+GENERIC_CHAR_MAP_IMPLEMENT(int_char_map, int);
+
+GENERIC_FIELD_DECLARE(int_field, int);
+GENERIC_FIELD_IMPLEMENT(int_field, int);
+
+INT_MAP_DECLARE(int_map, int);
+INT_MAP_IMPLEMENT(int_map, int);
+
+/** Self-test start function.
+ *
+ * Run all self-tests.
+ *
+ * @returns EOK on success.
+ * @returns The first error occurred.
+ *
+ */
+int self_test(void)
+{
+	printf("Running networking self-tests\n");
+	
+	printf("\nChar map test");
+	char_map_t cm;
+	
+	TEST(char_map_update(&cm, "ucho", 0, 3), EINVAL);
+	TEST(char_map_initialize(&cm), EOK);
+	TEST(char_map_exclude(&cm, "bla", 0), CHAR_MAP_NULL);
+	TEST(char_map_find(&cm, "bla", 0), CHAR_MAP_NULL);
+	TEST(char_map_add(&cm, "bla", 0, 1), EOK);
+	TEST(char_map_find(&cm, "bla", 0), 1);
+	TEST(char_map_add(&cm, "bla", 0, 10), EEXISTS);
+	TEST(char_map_update(&cm, "bla", 0, 2), EOK);
+	TEST(char_map_find(&cm, "bla", 0), 2);
+	TEST(char_map_update(&cm, "ucho", 0, 2), EOK);
+	TEST(char_map_exclude(&cm, "bla", 0), 2);
+	TEST(char_map_exclude(&cm, "bla", 0), CHAR_MAP_NULL);
+	TEST(char_map_find(&cm, "ucho", 0), 2);
+	TEST(char_map_update(&cm, "ucho", 0, 3), EOK);
+	TEST(char_map_find(&cm, "ucho", 0), 3);
+	TEST(char_map_add(&cm, "blabla", 0, 5), EOK);
+	TEST(char_map_find(&cm, "blabla", 0), 5);
+	TEST(char_map_add(&cm, "bla", 0, 6), EOK);
+	TEST(char_map_find(&cm, "bla", 0), 6);
+	TEST(char_map_exclude(&cm, "bla", 0), 6);
+	TEST(char_map_find(&cm, "bla", 0), CHAR_MAP_NULL);
+	TEST(char_map_find(&cm, "blabla", 0), 5);
+	TEST(char_map_add(&cm, "auto", 0, 7), EOK);
+	TEST(char_map_find(&cm, "auto", 0), 7);
+	TEST(char_map_add(&cm, "kara", 0, 8), EOK);
+	TEST(char_map_find(&cm, "kara", 0), 8);
+	TEST(char_map_add(&cm, "nic", 0, 9), EOK);
+	TEST(char_map_find(&cm, "nic", 0), 9);
+	TEST(char_map_find(&cm, "blabla", 0), 5);
+	TEST(char_map_add(&cm, "micnicnic", 5, 9), EOK);
+	TEST(char_map_find(&cm, "micni", 0), 9);
+	TEST(char_map_find(&cm, "micnicn", 5), 9);
+	TEST(char_map_add(&cm, "\x10\x0\x2\x2", 4, 15), EOK);
+	TEST(char_map_find(&cm, "\x10\x0\x2\x2", 4), 15);
+	
+	TEST((char_map_destroy(&cm), EOK), EOK);
+	TEST(char_map_update(&cm, "ucho", 0, 3), EINVAL);
+	
+	printf("\nCRC computation test");
+	uint32_t value;
+	
+	TEST(value = ~compute_crc32(~0, "123456789", 8 * 9), 0xcbf43926);
+	TEST(value = ~compute_crc32(~0, "1", 8), 0x83dcefb7);
+	TEST(value = ~compute_crc32(~0, "12", 8 * 2), 0x4f5344cd);
+	TEST(value = ~compute_crc32(~0, "123", 8 * 3), 0x884863d2);
+	TEST(value = ~compute_crc32(~0, "1234", 8 * 4), 0x9be3e0a3);
+	TEST(value = ~compute_crc32(~0, "12345678", 8 * 8), 0x9ae0daaf);
+	TEST(value = ~compute_crc32(~0, "ahoj pane", 8 * 9), 0x5fc3d706);
+	
+	printf("\nDynamic fifo test");
+	dyn_fifo_t fifo;
+	
+	TEST(dyn_fifo_push(&fifo, 1, 0), EINVAL);
+	TEST(dyn_fifo_initialize(&fifo, 1), EOK);
+	TEST(dyn_fifo_push(&fifo, 1, 0), EOK);
+	TEST(dyn_fifo_pop(&fifo), 1);
+	TEST(dyn_fifo_pop(&fifo), ENOENT);
+	TEST(dyn_fifo_push(&fifo, 2, 1), EOK);
+	TEST(dyn_fifo_push(&fifo, 3, 1), ENOMEM);
+	TEST(dyn_fifo_push(&fifo, 3, 0), EOK);
+	TEST(dyn_fifo_pop(&fifo), 2);
+	TEST(dyn_fifo_pop(&fifo), 3);
+	TEST(dyn_fifo_push(&fifo, 4, 2), EOK);
+	TEST(dyn_fifo_push(&fifo, 5, 2), EOK);
+	TEST(dyn_fifo_push(&fifo, 6, 2), ENOMEM);
+	TEST(dyn_fifo_push(&fifo, 6, 5), EOK);
+	TEST(dyn_fifo_push(&fifo, 7, 5), EOK);
+	TEST(dyn_fifo_pop(&fifo), 4);
+	TEST(dyn_fifo_pop(&fifo), 5);
+	TEST(dyn_fifo_push(&fifo, 8, 5), EOK);
+	TEST(dyn_fifo_push(&fifo, 9, 5), EOK);
+	TEST(dyn_fifo_push(&fifo, 10, 6), EOK);
+	TEST(dyn_fifo_push(&fifo, 11, 6), EOK);
+	TEST(dyn_fifo_pop(&fifo), 6);
+	TEST(dyn_fifo_pop(&fifo), 7);
+	TEST(dyn_fifo_push(&fifo, 12, 6), EOK);
+	TEST(dyn_fifo_push(&fifo, 13, 6), EOK);
+	TEST(dyn_fifo_push(&fifo, 14, 6), ENOMEM);
+	TEST(dyn_fifo_push(&fifo, 14, 8), EOK);
+	TEST(dyn_fifo_pop(&fifo), 8);
+	TEST(dyn_fifo_pop(&fifo), 9);
+	TEST(dyn_fifo_pop(&fifo), 10);
+	TEST(dyn_fifo_pop(&fifo), 11);
+	TEST(dyn_fifo_pop(&fifo), 12);
+	TEST(dyn_fifo_pop(&fifo), 13);
+	TEST(dyn_fifo_pop(&fifo), 14);
+	TEST(dyn_fifo_destroy(&fifo), EOK);
+	TEST(dyn_fifo_push(&fifo, 1, 0), EINVAL);
+	
+	printf("\nGeneric char map test");
+	
+	int *x;
+	int *y;
+	int *z;
+	int *u;
+	int *v;
+	int *w;
+	
+	XMALLOC(x, int);
+	XMALLOC(y, int);
+	XMALLOC(z, int);
+	XMALLOC(u, int);
+	XMALLOC(v, int);
+	XMALLOC(w, int);
+	
+	int_char_map_t icm;
+	icm.magic = 0;
+	
+	TEST(int_char_map_add(&icm, "ucho", 0, z), EINVAL);
+	TEST(int_char_map_initialize(&icm), EOK);
+	TEST((int_char_map_exclude(&icm, "bla", 0), EOK), EOK);
+	TEST(int_char_map_find(&icm, "bla", 0), NULL);
+	TEST(int_char_map_add(&icm, "bla", 0, x), EOK);
+	TEST(int_char_map_find(&icm, "bla", 0), x);
+	TEST(int_char_map_add(&icm, "bla", 0, y), EEXISTS);
+	TEST((int_char_map_exclude(&icm, "bla", 0), EOK), EOK);
+	TEST((int_char_map_exclude(&icm, "bla", 0), EOK), EOK);
+	TEST(int_char_map_add(&icm, "blabla", 0, v), EOK);
+	TEST(int_char_map_find(&icm, "blabla", 0), v);
+	TEST(int_char_map_add(&icm, "bla", 0, w), EOK);
+	TEST(int_char_map_find(&icm, "bla", 0), w);
+	TEST((int_char_map_exclude(&icm, "bla", 0), EOK), EOK);
+	TEST(int_char_map_find(&icm, "bla", 0), NULL);
+	TEST(int_char_map_find(&icm, "blabla", 0), v);
+	TEST(int_char_map_add(&icm, "auto", 0, u), EOK);
+	TEST(int_char_map_find(&icm, "auto", 0), u);
+	TEST((int_char_map_destroy(&icm), EOK), EOK);
+	TEST(int_char_map_add(&icm, "ucho", 0, z), EINVAL);
+	
+	printf("\nGeneric field test");
+	
+	XMALLOC(x, int);
+	XMALLOC(y, int);
+	XMALLOC(z, int);
+	XMALLOC(u, int);
+	XMALLOC(v, int);
+	XMALLOC(w, int);
+	
+	int_field_t gf;
+	gf.magic = 0;
+	
+	TEST(int_field_add(&gf, x), EINVAL);
+	TEST(int_field_count(&gf), -1);
+	TEST(int_field_initialize(&gf), EOK);
+	TEST(int_field_count(&gf), 0);
+	TEST(int_field_get_index(&gf, 1), NULL);
+	TEST(int_field_add(&gf, x), 0);
+	TEST(int_field_get_index(&gf, 0), x);
+	TEST((int_field_exclude_index(&gf, 0), EOK), EOK);
+	TEST(int_field_get_index(&gf, 0), NULL);
+	TEST(int_field_add(&gf, y), 1);
+	TEST(int_field_get_index(&gf, 1), y);
+	TEST(int_field_add(&gf, z), 2);
+	TEST(int_field_get_index(&gf, 2), z);
+	TEST(int_field_get_index(&gf, 1), y);
+	TEST(int_field_count(&gf), 3);
+	TEST(int_field_add(&gf, u), 3);
+	TEST(int_field_get_index(&gf, 3), u);
+	TEST(int_field_add(&gf, v), 4);
+	TEST(int_field_get_index(&gf, 4), v);
+	TEST(int_field_add(&gf, w), 5);
+	TEST(int_field_get_index(&gf, 5), w);
+	TEST(int_field_count(&gf), 6);
+	TEST((int_field_exclude_index(&gf, 1), EOK), EOK);
+	TEST(int_field_get_index(&gf, 1), NULL);
+	TEST(int_field_get_index(&gf, 3), u);
+	TEST((int_field_exclude_index(&gf, 7), EOK), EOK);
+	TEST(int_field_get_index(&gf, 3), u);
+	TEST(int_field_get_index(&gf, 5), w);
+	TEST((int_field_exclude_index(&gf, 4), EOK), EOK);
+	TEST(int_field_get_index(&gf, 4), NULL);
+	TEST((int_field_destroy(&gf), EOK), EOK);
+	TEST(int_field_count(&gf), -1);
+	
+	printf("\nInt map test");
+	
+	XMALLOC(x, int);
+	XMALLOC(y, int);
+	XMALLOC(z, int);
+	XMALLOC(u, int);
+	XMALLOC(v, int);
+	XMALLOC(w, int);
+	
+	int_map_t im;
+	im.magic = 0;
+	
+	TEST(int_map_add(&im, 1, x), EINVAL);
+	TEST(int_map_count(&im), -1);
+	TEST(int_map_initialize(&im), EOK);
+	TEST(int_map_count(&im), 0);
+	TEST(int_map_find(&im, 1), NULL);
+	TEST(int_map_add(&im, 1, x), 0);
+	TEST(int_map_find(&im, 1), x);
+	TEST((int_map_exclude(&im, 1), EOK), EOK);
+	TEST(int_map_find(&im, 1), NULL);
+	TEST(int_map_add(&im, 1, y), 1);
+	TEST(int_map_find(&im, 1), y);
+	TEST(int_map_add(&im, 4, z), 2);
+	TEST(int_map_get_index(&im, 2), z);
+	TEST(int_map_find(&im, 4), z);
+	TEST(int_map_find(&im, 1), y);
+	TEST(int_map_count(&im), 3);
+	TEST(int_map_add(&im, 2, u), 3);
+	TEST(int_map_find(&im, 2), u);
+	TEST(int_map_add(&im, 3, v), 4);
+	TEST(int_map_find(&im, 3), v);
+	TEST(int_map_get_index(&im, 4), v);
+	TEST(int_map_add(&im, 6, w), 5);
+	TEST(int_map_find(&im, 6), w);
+	TEST(int_map_count(&im), 6);
+	TEST((int_map_exclude(&im, 1), EOK), EOK);
+	TEST(int_map_find(&im, 1), NULL);
+	TEST(int_map_find(&im, 2), u);
+	TEST((int_map_exclude(&im, 7), EOK), EOK);
+	TEST(int_map_find(&im, 2), u);
+	TEST(int_map_find(&im, 6), w);
+	TEST((int_map_exclude_index(&im, 4), EOK), EOK);
+	TEST(int_map_get_index(&im, 4), NULL);
+	TEST(int_map_find(&im, 3), NULL);
+	TEST((int_map_destroy(&im), EOK), EOK);
+	TEST(int_map_count(&im), -1);
+	
+	printf("\nMeasured strings test");
+	
+	measured_string_ref string =
+	    measured_string_create_bulk("I am a measured string!", 0);
+	printf("\n%x, %s at %x of %d\n", string, string->value, string->value,
+	    string->length);
+	
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/app/netstart/self_test.h
===================================================================
--- uspace/app/netstart/self_test.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/app/netstart/self_test.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,41 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup net
+ * @{
+ */
+
+#ifndef __SELF_TEST_H__
+#define __SELF_TEST_H__
+
+extern int self_test(void);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/nic/nic.c
===================================================================
--- uspace/app/nic/nic.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/nic/nic.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,4 @@
 #include <stdlib.h>
 #include <stddef.h>
-#include <str.h>
 #include <str_error.h>
 
@@ -73,5 +72,5 @@
 static async_sess_t *get_nic_by_index(size_t i)
 {
-	errno_t rc;
+	int rc;
 	size_t count;
 	char *svc_name;
@@ -111,10 +110,10 @@
 }
 
-static errno_t nic_get_info(service_id_t svc_id, char *svc_name,
+static int nic_get_info(service_id_t svc_id, char *svc_name,
     nic_info_t *info)
 {
 	async_sess_t *sess;
 	nic_role_t role;
-	errno_t rc;
+	int rc;
 
 	sess = loc_service_connect(svc_id, INTERFACE_DDF, 0);
@@ -246,5 +245,5 @@
 }
 
-static errno_t nic_list(void)
+static int nic_list(void)
 {
 	category_id_t nic_cat;
@@ -254,5 +253,5 @@
 	char *svc_name;
 	char *addr_str;
-	errno_t rc;
+	int rc;
 
 	rc = loc_category_get_id("nic", &nic_cat, 0);
@@ -317,5 +316,5 @@
 }
 
-static errno_t nic_set_speed(int i, char *str)
+static int nic_set_speed(int i, char *str)
 {
 	async_sess_t *sess;
@@ -324,5 +323,5 @@
 	nic_channel_mode_t oldduplex;
 	nic_role_t oldrole;
-	errno_t rc;
+	int rc;
 
 	rc = str_uint32_t(str, NULL, 10, false, &speed);
@@ -352,5 +351,5 @@
 }
 
-static errno_t nic_set_duplex(int i, char *str)
+static int nic_set_duplex(int i, char *str)
 {
 	async_sess_t *sess;
@@ -359,5 +358,5 @@
 	nic_channel_mode_t oldduplex;
 	nic_role_t oldrole;
-	errno_t rc;
+	int rc;
 
 	if (!str_cmp(str, "half"))
@@ -390,8 +389,8 @@
 }
 
-static errno_t nic_set_autoneg(int i)
-{
-	async_sess_t *sess;
-	errno_t rc;
+static int nic_set_autoneg(int i)
+{
+	async_sess_t *sess;
+	int rc;
 
 	sess = get_nic_by_index(i);
@@ -410,10 +409,9 @@
 }
 
-static errno_t nic_set_addr(int i, char *str)
+static int nic_set_addr(int i, char *str)
 {
 	async_sess_t *sess;
 	nic_address_t addr;
-	errno_t rc;
-	int idx;
+	int rc, idx;
 
 	sess = get_nic_by_index(i);
@@ -439,5 +437,5 @@
 }
 
-static errno_t nic_set_rx_unicast(int i, char *str)
+static int nic_set_rx_unicast(int i, char *str)
 {
 	async_sess_t *sess;
@@ -474,5 +472,5 @@
 }
 
-static errno_t nic_set_rx_multicast(int i, char *str)
+static int nic_set_rx_multicast(int i, char *str)
 {
 	async_sess_t *sess;
@@ -503,5 +501,5 @@
 }
 
-static errno_t nic_set_rx_broadcast(int i, char *str)
+static int nic_set_rx_broadcast(int i, char *str)
 {
 	async_sess_t *sess;
@@ -529,5 +527,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	uint32_t index;
 
Index: uspace/app/nterm/conn.c
===================================================================
--- uspace/app/nterm/conn.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/nterm/conn.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -69,5 +69,5 @@
 static void conn_data_avail(tcp_conn_t *conn)
 {
-	errno_t rc;
+	int rc;
 	size_t nrecv;
 
@@ -75,5 +75,5 @@
 		rc = tcp_conn_recv(conn, recv_buf, RECV_BUF_SIZE, &nrecv);
 		if (rc != EOK) {
-			printf("\n[Receive error: %s]\n", str_error_name(rc));
+			printf("\n[Receive error %d]\n", rc);
 			break;
 		}
@@ -86,9 +86,9 @@
 }
 
-errno_t conn_open(const char *hostport)
+int conn_open(const char *hostport)
 {
 	inet_ep2_t epp;
 	const char *errmsg;
-	errno_t rc;
+	int rc;
 
 	inet_ep2_init(&epp);
@@ -126,7 +126,7 @@
 }
 
-errno_t conn_send(void *data, size_t size)
+int conn_send(void *data, size_t size)
 {
-	errno_t rc = tcp_conn_send(conn, data, size);
+	int rc = tcp_conn_send(conn, data, size);
 	if (rc != EOK)
 		return EIO;
Index: uspace/app/nterm/conn.h
===================================================================
--- uspace/app/nterm/conn.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/nterm/conn.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,6 +39,6 @@
 #include <stddef.h>
 
-extern errno_t conn_open(const char *);
-extern errno_t conn_send(void *, size_t);
+extern int conn_open(const char *);
+extern int conn_send(void *, size_t);
 
 #endif
Index: uspace/app/nterm/nterm.c
===================================================================
--- uspace/app/nterm/nterm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/nterm/nterm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #include <io/console.h>
 #include <stdio.h>
-#include <str.h>
 
 #include "conn.h"
@@ -62,5 +61,5 @@
 	char cbuf[STR_BOUNDS(1)];
 	size_t offs;
-	errno_t rc;
+	int rc;
 
 	offs = 0;
@@ -111,5 +110,5 @@
 {
 	cons_event_t ev;
-	errno_t rc;
+	int rc;
 
 	if (argc != 2) {
Index: uspace/app/ping/ping.c
===================================================================
--- uspace/app/ping/ping.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/ping/ping.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -71,5 +71,5 @@
 static FIBRIL_MUTEX_INITIALIZE(quit_lock);
 
-static errno_t ping_ev_recv(inetping_sdu_t *);
+static int ping_ev_recv(inetping_sdu_t *);
 
 static inetping_ev_ops_t ev_ops = {
@@ -109,8 +109,8 @@
 }
 
-static errno_t ping_ev_recv(inetping_sdu_t *sdu)
+static int ping_ev_recv(inetping_sdu_t *sdu)
 {
 	char *asrc;
-	errno_t rc = inet_addr_format(&src_addr, &asrc);
+	int rc = inet_addr_format(&src_addr, &asrc);
 	if (rc != EOK)
 		return ENOMEM;
@@ -133,5 +133,5 @@
 }
 
-static errno_t ping_send(uint16_t seq_no)
+static int ping_send(uint16_t seq_no)
 {
 	inetping_sdu_t sdu;
@@ -143,13 +143,13 @@
 	sdu.size = 3;
 	
-	errno_t rc = inetping_send(&sdu);
+	int rc = inetping_send(&sdu);
 	if (rc != EOK)
-		printf("Failed sending echo request: %s: %s.\n",
-		    str_error_name(rc), str_error(rc));
+		printf("Failed sending echo request: %s (%d).\n",
+		    str_error(rc), rc);
 	
 	return rc;
 }
 
-static errno_t transmit_fibril(void *arg)
+static int transmit_fibril(void *arg)
 {
 	uint16_t seq_no = 0;
@@ -163,5 +163,5 @@
 		
 		fibril_mutex_lock(&received_lock);
-		errno_t rc = fibril_condvar_wait_timeout(&received_cv, &received_lock,
+		int rc = fibril_condvar_wait_timeout(&received_cv, &received_lock,
 		    PING_TIMEOUT);
 		received_t recv = received;
@@ -190,5 +190,5 @@
 }
 
-static errno_t input_fibril(void *arg)
+static int input_fibril(void *arg)
 {
 	console_ctrl_t *con = console_init(stdin, stdout);
@@ -222,8 +222,8 @@
 	ip_ver_t ip_ver = ip_any;
 	
-	errno_t rc = inetping_init(&ev_ops);
+	int rc = inetping_init(&ev_ops);
 	if (rc != EOK) {
 		printf("Failed connecting to internet ping service: "
-		    "%s: %s.\n", str_error_name(rc), str_error(rc));
+		    "%s (%d).\n", str_error(rc), rc);
 		goto error;
 	}
@@ -290,5 +290,6 @@
 	}
 	
-	if (asprintf(&sdest, "%s (%s)", host, adest) < 0) {
+	rc = asprintf(&sdest, "%s (%s)", host, adest);
+	if (rc < 0) {
 		printf("Out of memory.\n");
 		goto error;
Index: uspace/app/pkg/pkg.c
===================================================================
--- uspace/app/pkg/pkg.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/pkg/pkg.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 #include <str_error.h>
 #include <task.h>
@@ -50,5 +49,5 @@
 }
 
-static errno_t cmd_runl(const char *path, ...)
+static int cmd_runl(const char *path, ...)
 {
 	va_list ap;
@@ -66,5 +65,5 @@
 	task_id_t id;
 	task_wait_t wait;
-	errno_t rc = task_spawn(&id, &wait, path, cnt, ap);
+	int rc = task_spawn(&id, &wait, path, cnt, ap);
 	va_end(ap);
 
@@ -97,9 +96,9 @@
 	}
 
-	return retval == 0 ? EOK : EPARTY;
-}
-
-
-static errno_t pkg_install(int argc, char *argv[])
+	return retval;
+}
+
+
+static int pkg_install(int argc, char *argv[])
 {
 	char *pkg_name;
@@ -107,6 +106,5 @@
 	char *fname;
 	char *fnunpack;
-	errno_t rc;
-	int ret;
+	int rc;
 
 	if (argc != 3) {
@@ -117,22 +115,22 @@
 	pkg_name = argv[2];
 
-	ret = asprintf(&src_uri, "http://ci.helenos.org/latest/" STRING(UARCH)
+	rc = asprintf(&src_uri, "http://ci.helenos.org/latest/" STRING(UARCH)
 	    "/%s-for-helenos-" STRING(UARCH) ".tar.gz",
 	    pkg_name);
-	if (ret < 0) {
+	if (rc < 0) {
 		printf("Out of memory.\n");
 		return ENOMEM;
 	}
 
-	ret = asprintf(&fname, "/tmp/%s-for-helenos-" STRING(UARCH)
+	rc = asprintf(&fname, "/tmp/%s-for-helenos-" STRING(UARCH)
 	    ".tar.gz", pkg_name);
-	if (ret < 0) {
+	if (rc < 0) {
 		printf("Out of memory.\n");
 		return ENOMEM;
 	}
 
-	ret = asprintf(&fnunpack, "/tmp/%s-for-helenos-" STRING(UARCH) ".tar",
+	rc = asprintf(&fnunpack, "/tmp/%s-for-helenos-" STRING(UARCH) ".tar",
 	    pkg_name);
-	if (ret < 0) {
+	if (rc < 0) {
 		printf("Out of memory.\n");
 		return ENOMEM;
@@ -182,5 +180,5 @@
 {
 	char *cmd;
-	errno_t rc;
+	int rc;
 
 	if (argc < 2) {
Index: uspace/app/rcubench/rcubench.c
===================================================================
--- uspace/app/rcubench/rcubench.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/rcubench/rcubench.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,4 @@
 #include <compiler/barrier.h>
 #include <futex.h>
-#include <str.h>
 
 #include <rcu.h>
@@ -127,5 +126,5 @@
 		thread_id_t tid;
 		/* Also sets up a fibril for the thread. */
-		errno_t ret = thread_create(thread_func, bench, "rcubench-t", &tid);
+		int ret = thread_create(thread_func, bench, "rcubench-t", &tid);
 		if (ret != EOK) {
 			printf("Error: Failed to create benchmark thread.\n");
@@ -218,5 +217,5 @@
 	/* Determine iteration count. */
 	uint32_t iter_cnt = 0;
-	errno_t ret = str_uint32_t(argv[2], NULL, 0, true, &iter_cnt);
+	int ret = str_uint32_t(argv[2], NULL, 0, true, &iter_cnt);
 
 	if (ret == EOK && 1 <= iter_cnt) {
Index: uspace/app/rcutest/rcutest.c
===================================================================
--- uspace/app/rcutest/rcutest.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/rcutest/rcutest.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #include <stdlib.h>
 #include <stdint.h>
-#include <str_error.h>
 #include <mem.h>
 #include <errno.h>
@@ -48,5 +47,4 @@
 #include <compiler/barrier.h>
 #include <futex.h>
-#include <str.h>
 
 #include <rcu.h>
@@ -169,7 +167,7 @@
 
 
-typedef errno_t (*fibril_func_t)(void *);
-
-static bool create_fibril(errno_t (*func)(void*), void *arg)
+typedef int (*fibril_func_t)(void *);
+
+static bool create_fibril(int (*func)(void*), void *arg)
 {
 	fid_t fid = fibril_create(func, arg);
@@ -309,5 +307,5 @@
 
 
-static errno_t sleeping_reader(one_reader_info_t *arg)
+static int sleeping_reader(one_reader_info_t *arg)
 {
 	rcu_register_fibril();
@@ -391,5 +389,5 @@
 
 
-static errno_t preexisting_reader(two_reader_info_t *arg)
+static int preexisting_reader(two_reader_info_t *arg)
 {
 	rcu_register_fibril();
@@ -431,5 +429,5 @@
 }
 
-static errno_t new_reader(two_reader_info_t *arg)
+static int new_reader(two_reader_info_t *arg)
 {
 	rcu_register_fibril();
@@ -552,5 +550,5 @@
 
 
-static errno_t exiting_locked_reader(exit_reader_info_t *arg)
+static int exiting_locked_reader(exit_reader_info_t *arg)
 {
 	rcu_register_fibril();
@@ -648,5 +646,5 @@
 }
 
-static errno_t seq_reader(seq_test_info_t *arg)
+static int seq_reader(seq_test_info_t *arg)
 {
 	rcu_register_fibril();
@@ -691,5 +689,5 @@
 }
 
-static errno_t seq_updater(seq_test_info_t *arg)
+static int seq_updater(seq_test_info_t *arg)
 {
 	rcu_register_fibril();
@@ -780,7 +778,7 @@
 		thread_id_t tid;
 		
-		errno_t ret = thread_create(dummy_fibril, NULL, "urcu-test-worker", &tid);
+		int ret = thread_create(dummy_fibril, NULL, "urcu-test-worker", &tid);
 		if (EOK != ret) {
-			printf("Failed to create thread '%zu' (error: %s)\n", k + 1, str_error_name(ret));
+			printf("Failed to create thread '%zu' (error: %d)\n", k + 1, ret);
 			return false;
 		}
@@ -863,5 +861,5 @@
 	if (argc == 3) {
 		uint32_t thread_cnt = 0;
-		errno_t ret = str_uint32_t(argv[2], NULL, 0, true, &thread_cnt);
+		int ret = str_uint32_t(argv[2], NULL, 0, true, &thread_cnt);
 		
 		if (ret == EOK && 1 <= thread_cnt && thread_cnt <= 64) {
Index: uspace/app/redir/redir.c
===================================================================
--- uspace/app/redir/redir.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/redir/redir.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -59,16 +59,12 @@
 	*stream = NULL;
 	
-	int oldfd;
-	errno_t rc = vfs_lookup_open(path, WALK_REGULAR | flags, mode, &oldfd);
-	if (rc != EOK)
+	int oldfd = vfs_lookup_open(path, WALK_REGULAR | flags, mode);
+	if (oldfd < 0)
 		return;
 	
 	if (oldfd != fd) {
-		int newfd;
-		if (vfs_clone(oldfd, fd, false, &newfd) != EOK)
+		if (vfs_clone(oldfd, fd, false) != fd)
 			return;
 		
-		assert(newfd == fd);
-
 		if (vfs_put(oldfd))
 			return;
@@ -82,5 +78,5 @@
 	const char **args;
 	task_id_t id = 0;
-	errno_t rc;
+	int rc;
 
 	args = (const char **) calloc(argc + 1, sizeof(char *));
Index: uspace/app/sbi/src/bigint.c
===================================================================
--- uspace/app/sbi/src/bigint.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/bigint.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -186,5 +186,5 @@
  *			to @a dval.
  */
-errno_t bigint_get_value_int(bigint_t *bigint, int *dval)
+int bigint_get_value_int(bigint_t *bigint, int *dval)
 {
 	bigint_t vval, diff;
Index: uspace/app/sbi/src/bigint.h
===================================================================
--- uspace/app/sbi/src/bigint.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/bigint.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 void bigint_destroy(bigint_t *bigint);
 
-errno_t bigint_get_value_int(bigint_t *bigint, int *dval);
+int bigint_get_value_int(bigint_t *bigint, int *dval);
 bool_t bigint_is_zero(bigint_t *bigint);
 bool_t bigint_is_negative(bigint_t *bigint);
Index: uspace/app/sbi/src/builtin/bi_char.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_char.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/builtin/bi_char.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -73,5 +73,5 @@
         char *str;
         int char_val;
-        errno_t rc;
+        int rc;
 
 #ifdef DEBUG_RUN_TRACE
Index: uspace/app/sbi/src/builtin/bi_console.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_console.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/builtin/bi_console.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -107,5 +107,5 @@
 	rdata_var_t *var;
 	int char_val;
-	errno_t rc;
+	int rc;
 
 #ifdef DEBUG_RUN_TRACE
Index: uspace/app/sbi/src/builtin/bi_string.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_string.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/builtin/bi_string.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -125,5 +125,5 @@
 	int length;
 
-	errno_t rc;
+	int rc;
 
 	/* Extract self.Value */
Index: uspace/app/sbi/src/input.c
===================================================================
--- uspace/app/sbi/src/input.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/input.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,5 @@
 #define INPUT_BUFFER_SIZE 256
 
-static errno_t input_init_file(input_t *input, const char *fname);
+static int input_init_file(input_t *input, const char *fname);
 static void input_init_interactive(input_t *input);
 static void input_init_string(input_t *input, const char *str);
@@ -57,5 +57,5 @@
  *			ENOENT when opening file fails.
  */
-errno_t input_new_file(input_t **input, const char *fname)
+int input_new_file(input_t **input, const char *fname)
 {
 	*input = malloc(sizeof(input_t));
@@ -71,5 +71,5 @@
  * @return		EOK on success, ENOMEM when allocation fails.
  */
-errno_t input_new_interactive(input_t **input)
+int input_new_interactive(input_t **input)
 {
 	*input = malloc(sizeof(input_t));
@@ -87,5 +87,5 @@
  * @return		EOK on success, ENOMEM when allocation fails.
  */
-errno_t input_new_string(input_t **input, const char *str)
+int input_new_string(input_t **input, const char *str)
 {
 	*input = malloc(sizeof(input_t));
@@ -104,5 +104,5 @@
  * @return		EOK on success, ENOENT when opening file fails.
 */
-static errno_t input_init_file(input_t *input, const char *fname)
+static int input_init_file(input_t *input, const char *fname)
 {
 	FILE *f;
@@ -174,5 +174,5 @@
  * @return		EOK on success, EIO on failure.
  */
-errno_t input_get_line(input_t *input, char **line)
+int input_get_line(input_t *input, char **line)
 {
 	const char *prompt;
Index: uspace/app/sbi/src/input.h
===================================================================
--- uspace/app/sbi/src/input.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/input.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -32,9 +32,9 @@
 #include "mytypes.h"
 
-errno_t input_new_file(input_t **input, const char *fname);
-errno_t input_new_interactive(input_t **input);
-errno_t input_new_string(input_t **input, const char *str);
+int input_new_file(input_t **input, const char *fname);
+int input_new_interactive(input_t **input);
+int input_new_string(input_t **input, const char *str);
 
-errno_t input_get_line(input_t *input, char **line);
+int input_get_line(input_t *input, char **line);
 int input_get_line_no(input_t *input);
 
Index: uspace/app/sbi/src/lex.c
===================================================================
--- uspace/app/sbi/src/lex.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/lex.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -257,5 +257,5 @@
 void lex_init(lex_t *lex, struct input *input)
 {
-	errno_t rc;
+	int rc;
 
 	lex->input = input;
@@ -717,5 +717,5 @@
 {
 	char *bp;
-	errno_t rc;
+	int rc;
 
 	bp = lex->ibp;
Index: uspace/app/sbi/src/main.c
===================================================================
--- uspace/app/sbi/src/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/sbi/src/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,5 +61,5 @@
 	stype_t stype;
 	run_t run;
-	errno_t rc;
+	int rc;
 
 	/* Store executable file path under which we have been invoked. */
